package com.accord.mega.batch.test;

import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import com.accord.mega.exception.MegaExceptionBA;
import com.accord.mega.objects.MegaUserBA;
import com.mega.modeling.api.MegaApplication;
import com.mega.modeling.api.MegaCollection;
import com.mega.modeling.api.MegaDatabase;
import com.mega.modeling.api.MegaDatabases;
import com.mega.modeling.api.MegaEnvironment;
import com.mega.modeling.api.MegaObject;
import com.mega.modeling.api.MegaRoot;
import com.mega.modeling.api.MegaTransaction;
import com.mega.modeling.api.MegaTransactions;
import com.mega.modeling.api.MegaUser;

public class TestProcessusMega {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Throwable {
		Map<String,String> usersWithTransaction = new HashMap<String,String>();
		Map<String,String> databaseNamesMap = new HashMap<String,String>();
		Map<String,String> usersMap = new HashMap<String,String>();
		
		MegaRoot mrMain = null;
		try{
			MegaApplication ma = new MegaApplication();
			File environmentFolder = new File("\\\\banque-accord.com/fichiers/mega/environnements/production");
			MegaEnvironment me = ma.getEnvironments().get(environmentFolder.getAbsolutePath());
			// Get databases
			MegaDatabases mds = me.databases();
			Iterator<MegaDatabase> ite = mds.iterator();
			// FOR EACH DATABASE
			while (ite.hasNext()) {
				MegaDatabase md = (MegaDatabase) ite.next();
				databaseNamesMap.put(md.getName(), md.getName());
			}

			MegaDatabase mdSysDb = mds.get("SystemDb");
			mrMain = mdSysDb.open();			
			/*try{
				MegaCollection mc = mrMain.getSelection("Select [Utilisateur]", "");
				Iterator<MegaObject> iteUsers = mc.iterator();
				while (iteUsers.hasNext()) {
					MegaObject mo = (MegaObject) iteUsers.next();
					usersMap.put(mo.getProp("Identifiant absolu"),mo.getProp("Name"));
				}
			}catch(Exception e){
				throw new MegaExceptionBA(e);
			}finally{
			}*/
			
			// get users with opened transaction
			MegaTransactions mt = me.transactions();
			//mrMain = getMegaDatabase(maac).open();
			for (MegaTransaction megaTransaction : mt) {
				MegaUser user = megaTransaction.getOwnedUser();
				MegaObject myUserObject = mrMain.getObjectFromID(user.getObjectID());
				String userId = myUserObject.getProp("Identifiant absolu").toString();
				String name = user.getName();
				usersWithTransaction.put(userId,name);
			}
			mrMain.megaCommit();
		}catch(Exception e){
			if(mrMain!=null) mrMain.megaRollback();
			throw(new MegaExceptionBA(e));
		}finally{
			if(mrMain!=null){
				mrMain.close();
			}
		}
		
	}
}
